<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
require_once LIB_PATH . '/Extension/invocationTags/InvocationTags.php';
require_once MAX_PATH . '/lib/max/Plugin/Translation.php';
require_once MAX_PATH . '/www/admin/lib-zones.inc.php';

/**
 *
 * Invocation tag plugin.
 *
 */
 
class Plugins_InvocationTags_OxInvocationTags_FloorAdsAsync extends Plugins_InvocationTags
{


    /**
     * Return name of plugin
     *
     * @return string
     */
    function getName()
    {
        return $this->translate("Floor Ads Async Tag");
    }

    /**
     * Return the English name of the plugin. Used when
     * generating translation keys based on the plugin
     * name.
     *
     * @return string An English string describing the class.
     */
    function getNameEN()
    {
        return 'Floor Ads Async Tag';
    }

    /**
     * Check if plugin is allowed
     *
     * @return boolean  True - allowed, false - not allowed
     */
     function isAllowed($extra = null)
    {
		return true;
        
    }

    function getOrder()
    {
        parent::getOrder();
        return 18;
    } 

    /**
     * Return list of options
     *
     * @return array    Group of options
     */
    function getOptionsList()
    {
        if (is_array($this->defaultOptions)) {
            if (in_array('cacheBuster', $this->defaultOptions)) {
                unset($this->defaultOptions['cacheBuster']);
            }
        }
        $options = [
             'position' => 1,
            //  'height1' => 2,
            //  'width1' =>3,
            
            //~ 'block' => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            //~ 'blockcampaign' => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            'target' => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            'source' => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            
        ];

        return $options;
    }
    
    function position()
    {
            $maxInvocation = &$this->maxInvocation;
            $position = (!empty($maxInvocation->position)) ? $maxInvocation->position :$_POST['position'];;
            $option = '';
            $option .= "<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";
            $option .= "<tr><td width='30'>&nbsp;</td>
            <td width='200'>Dynamic floor Ad position</td><td width='370'>
            <select name='position' tabindex='".($maxInvocation->tabindex++)."'>
             <option value=''>-----Select-----</option>
             <option value='top'".($position=='top'?"selected='selected'":''). ">Top</option>
             <option value='bottom'".($position=='bottom'?"selected='selected'":''). ">Bottom</option>
            </select></tr>";
            $option .= "<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";

            return $option;
    }
    
  /*  function height1()
    {
        $maxInvocation = &$this->maxInvocation;
        
        $height1 = (!empty($maxInvocation->height1)) ? $maxInvocation->height1 :$_POST['height1'];;
        $option = '';
        $option .= "<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";
        $option .= "<tr><td width='30'>&nbsp;</td>
        <td width='200'>Dynamic floor ad height</td><td width='370'>
       <input type='text'  name='height1'  value='".(isset($maxInvocation->height1) ? $maxInvocation->height1 : '')."' style='width:50px;' tabindex='".($maxInvocation->tabindex++)."'></td></tr>";
        $option .= "<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";

        return $option;
    }
    function width1()
    {
        $maxInvocation = &$this->maxInvocation;
        $width1 = (!empty($maxInvocation->width1)) ? $maxInvocation->width1 :$_POST['width1'];;
        $option = '';
        $option .= "<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";
        $option .= "<tr><td width='30'>&nbsp;</td>
        <td width='200'>Dynamic floor ad width</td><td width='370'>
       <input type='text'  name='width1'  value='".(isset($maxInvocation->width1) ? $maxInvocation->width1 : '')."' style='width:50px;' tabindex='".($maxInvocation->tabindex++)."'></td></tr>";
        $option .= "<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";

        return $option;
    }*/
      /**
     * Return invocation code for this plugin (codetype)
     *
     * @return string
     */
    function generateInvocationCode()
    {
        $aComments = array(
            'SSL Backup Comment' => "",
            'SSL Delivery Comment' => "",
            'Comment'              => "",
        );
        parent::prepareCommonInvocationData($aComments);

        $conf = $GLOBALS['_MAX']['CONF'];
        $mi = &$this->maxInvocation;

        $buffer = $mi->buffer;

        if (isset($mi->block) && $mi->block == '1') {
            $mi->parameters['block'] = "block=1";
        }
        if (isset($mi->blockcampaign) && $mi->blockcampaign == '1') {
            $mi->parameters['blockcampaign'] = "blockcampaign=1";
        }
        
        if (isset($_POST['position']) && !empty($_POST['position'])) {
            $mi->parameters['position'] = "position=".$_POST['position'];
        }
        else{
            $mi->parameters['position'] = "position=bottom";
            
        }
        // if (isset($_POST['height1']) && !empty($_POST['height1'])) {
        //     $mi->parameters['height1'] = "height1=".$_POST['height1'];
        //     $height1 = $_POST['height1'];
        // }
        // if (isset($_POST['width1']) && !empty($_POST['width1'])) {
        //     $mi->parameters['width1'] = "width1=".$_POST['width1'];
        //     $width1 = $_POST['width1'];
        // }
        
        
        $admin_path='//'.$conf['webpath']['admin'].'/plugins/DynamicfloorAds/delivery/floorads_asyncjs.php';

        // The cachebuster for async tags isn't needed
        unset($mi->parameters['cb']);

        // Add ID
        $mi->parameters['id'] = 'id='.md5("{$conf['webpath']['delivery']}*{$conf['webpath']['deliverySSL']}");

        // Remap as tag attributes with data-revive prefix
        $mi->parameters = array_map(function ($v) use ($conf) {
            return preg_replace('#^(.*)=(.*)$#', 'data-'.$conf['var']['product'].'-$1="$2"', $v);
        }, $mi->parameters);

        $buffer .= "<ins ".join(" ", $mi->parameters)."></ins>".PHP_EOL;
        if ($conf['webpath']['delivery'] == $conf['webpath']['deliverySSL']) {
            // Yes, we can use the short version!
            $buffer .= '<script async src="'.$admin_path.'"></script>';
        } else {
            // Bummer, we need the longer variant
            $url = array(
                $admin_path,
                $admin_path,
            );
            $buffer.= <<<EOF
<script>
(function () {
  var d = document, s = d.createElement('script'), p = d.location.protocol,
      i = d.getElementsByTagName('ins'), j = i[i.length-1];
  try {
    s.src = p === 'http:' ? '{$url[0]}' :
      '{$url[1]}';
    s.async = true; j.appendChild(s);
  } catch (e) {}
})();
</script>
EOF;
        }

        return $buffer;
    }

 
    function setInvocation(&$invocation) {

        $this->maxInvocation = &$invocation;
        $this->maxInvocation->canDetectCharset = true;

    }


}

?>
